package net.knarcraft.blockhunt.command;
/**
 * Steffion's Engine - Made by Steffion.
 * <p>
 * You're allowed to use this engine for own usage, you're not allowed to
 * republish the engine. Using this for your own plugin is allowed when a
 * credit is placed somewhere in the plugin.
 * <p>
 * Thanks for your cooperate!
 *
 * @author Steffion
 */

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.ConfigC;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.manager.CommandManager;
import net.knarcraft.blockhunt.manager.MessageManager;
import net.knarcraft.blockhunt.manager.PermissionsManager;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class HelpCommand extends DefaultCommand {


    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        int amountCommands = 0;
        for (CommandManager command : MemoryStorage.commands) {
            if (command.usage != null) {
                amountCommands = amountCommands + 1;
            }
        }

        int maxPages = (int) Math.round(amountCommands / 3.0);
        if (maxPages <= 0) {
            maxPages = 1;
        }

        int page = 1;
        if (args.length == 1) {
            MessageManager.sendFMessage(player, ConfigC.chat_headerhigh, "header-" + BlockHunt.pdfFile.getName() + " %Nhelp page %A" + page + "%N/%A" + maxPages);
            int i = 1;
            for (CommandManager command : MemoryStorage.commands) {
                if (i <= 4) {
                    if (command.usage != null) {
                        if (PermissionsManager.hasPerm(player, command.permission, false)) {
                            MessageManager.sendMessage(player, "%A" + command.usage + "%N - " + MemoryStorage.messages.getFile().get(command.help.location));
                        } else {
                            MessageManager.sendMessage(player, "%MemoryStorage" + command.usage + "%N - " + MemoryStorage.messages.getFile().get(command.help.location));
                        }
                        i = i + 1;
                    }
                }
            }

        } else {
            try {
                page = Integer.parseInt(args[1]);
            } catch (NumberFormatException ignored) {
            }

            if (maxPages < page) {
                maxPages = page;
            }

            MessageManager.sendFMessage(player, ConfigC.chat_headerhigh, "header-" + BlockHunt.pdfFile.getName() + " %Nhelp page %A" + page + "%N/%A" + maxPages);

            int i = 1;
            for (CommandManager command : MemoryStorage.commands) {
                if (i <= (page * 4) + 4) {
                    if (command.usage != null) {
                        if (i >= ((page - 1) * 4) + 1 && i <= ((page - 1) * 4) + 4) {
                            if (PermissionsManager.hasPerm(player, command.permission, false)) {
                                MessageManager.sendMessage(player, "%A" + command.usage + "%N - " + MemoryStorage.messages.getFile().get(command.help.location));
                            } else {
                                MessageManager.sendMessage(player, "%MemoryStorage" + command.usage + "%N - " + MemoryStorage.messages.getFile().get(command.help.location));
                            }
                        }
                        i = i + 1;
                    }
                }
            }
        }
        MessageManager.sendFMessage(player, ConfigC.chat_headerhigh, "header-&oHelp Page");
        return true;
    }
}
